
#ifndef _GEN_H_
#define _GEN_H_

extern int palmode;
extern int gab;
extern int gab2;
extern int palbank2;

#define ROM_SIZE    (0x200000)
#define PCM_SIZE    (0x080000)

/* Global data */
extern byte palram[0x1000];
extern byte ram[0x10000];
extern byte rom[ROM_SIZE];
extern byte pcm[PCM_SIZE];
extern byte pal_select;
extern byte pal_bank;

/* Function prototypes */
void genesis_frame(int render);
void genesis_init(void);
void genesis_trash(void);
void genesis_reset(void);

/* Memory handlers for debugging */
unsigned int m68k_read_memory_8(unsigned int address);
unsigned int m68k_read_memory_16(unsigned int address);
void m68k_write_memory_8(unsigned int address, unsigned int value);
void m68k_write_memory_16(unsigned int address, unsigned int value);

/* Palette RAM write handlers */
void palram_w_8(unsigned int address, unsigned int value);
void palram_w_16(unsigned int address, unsigned int value);

#endif /* _GEN_H_ */
