
#ifndef _RENDER_H_
#define _RENDER_H_

/* Look-up table labels */
enum lut_id {
    LUT_BG  = 0,        /* Background to background merge */
    LUT_OBJ,            /* Object to object merge */
    LUT_BGOBJ,          /* Object to background merge */
    LUT_BGOBJ_STE,      /* Object to background merge (S/TE) */
    LUT_MAX,            /* End marker */
};

/* Global data */
extern byte bufb[];
extern byte cache[];
extern byte vram_dirty_list[];
extern word vram_dirty_queue[];
extern word vram_dirty_index;
extern int plane_a_enable;
extern int plane_a_start;
extern int plane_a_end;
extern int plane_w_enable;
extern int plane_w_start;
extern int plane_w_end;

/* Function prototypes */
void render_a(int line, byte *lb, int scrolla);
void render_b(int line, byte *lb, int scrollb);
void render_w(int line, byte *lb);
void render_line(int line);
void render_sprites(int line, byte *buf, byte *lut);
void mclr(byte *buf, int length);
void merge(byte *A, byte *B, int w, byte *C);
void strip(byte *src, byte mask, int length);
int get_hscroll(int plane, int line);
void cache_tiles(void);
void window_clip(int line);
void make_table(void);
int make_lut_bg(int bx, int ax);
int make_lut_obj(int bx, int sx);
int make_lut_bgobj(int bx, int ax);
int make_lut_bgobj_ste(int sx, int bx);
void remap(byte *src, word *dst, int length);


#endif /* _RENDER_H_ */
