
#ifndef _DOS_H_
#define _DOS_H_

#define BITMAP_WIDTH            (512)
#define BITMAP_HEIGHT           (224)
#define BITMAP_MARGIN           (32)
#define COLOR_BLACK             (ui_colors[0])
#define COLOR_WHITE             (ui_colors[1])

typedef struct {
    word pixel[3];
    byte xlat[3];
    byte r[3];
    byte g[3];
    byte b[3];
}t_pal_data;

/* Global data */
extern t_pal_data pal_data[0x200];
extern int ui_colors[0x40];
extern PALETTE gen_pal;
extern FILE *errorlog;
extern BITMAP *gen_bmp;
extern volatile int frame_count;
extern volatile int frame_skip;
extern volatile int fps;
extern volatile int tick_count;
extern volatile int old_tick_count;
extern int skip;
extern int quit;
extern char game_name[0x80];
extern char sram_name[0x80];

extern int dipused;
extern int dipbnk;
extern byte dipsw[2];

/* Function prototypes */
void tick_handler(void);
void init_machine(void);
void trash_machine(void);
void get_input(void);
int check_key(int code);
void error(char *format, ...);
void byteswap(char *mem, int length);
int load_file(char *filename, char *mem, int size);
int load_file_even(char *filename, char *mem, int size);
int load_file_odd(char *filename, char *mem, int size);
int save_file(char *filename, char *mem, int size);
void dos_update_audio(void);
void dos_update_video(void);
void msg_print(int x, int y, char *fmt, ...);
void add_msg(char *fmt, ...);

#endif /* _DOS_H_ */
