
#ifndef _DRIVER_H_
#define _DRIVER_H_

#define ROM_LOAD        (0)
#define ROM_LOAD_EVEN   (1)
#define ROM_LOAD_ODD    (2)

typedef struct
{
    char *name;
    byte *mem;
    int size;
    int offset;
    int flags;
}t_rominfo;

typedef struct
{
    char *drvname;
    char *name;
    t_rominfo *rom;
    void (*init)(void);
}t_driver;

/* Global data */
extern byte dip_used;
extern byte dip_bank;
extern byte dip_switch[2];
extern t_driver *game_driver;

/* Driver init functions */
void bloxeedc_init(void);
void borench_init(void);
void columns_init(void);
void columns2_init(void);
void ichident_init(void);
void potopoto_init(void);
void puyopuyo_init(void);
void puyopuya_init(void);
void puyopuy2_init(void);
void stkclmns_init(void);
void tantr_init(void);
void tantrbl_init(void);
void tforceac_init(void);
void tfacjp_init(void);
void tfacbl_init(void);
void zunkyou_init(void);

/* Function prototypes */
void print_driver_files(char *name);
void print_driver_list(void);
int load_driver(char *name);
void free_driver(void);
void swap(byte *src, byte *dst, int length, int odd);
int load_rom(t_rominfo *p);

#endif /* _DRIVER_H_ */
