
#include "shared.h"


int file_exist(char *filename)
{
    FILE *fd = fopen(filename, "rb");
    if(!fd) return (0);
    fclose(fd);
    return (1);
}


int load_file(char *filename, char *buf, int size)
{
    FILE *fd = fopen(filename, "rb");
    if(!fd) return (0);
    fread(buf, size, 1, fd);
    fclose(fd);
    return (1);
}


int save_file(char *filename, char *buf, int size)
{
    FILE *fd = NULL;
    if(!(fd = fopen(filename, "wb"))) return (0);
    fwrite(buf, size, 1, fd);
    fclose(fd);
    return (1);
}


int load_zip(char *archname, char *filename, char *buf, int size)
{
    int ret = 0;
    unzFile *fd = NULL;
    unz_file_info info;

    /* Attempt to open the archive */
    fd = unzOpen(archname);
    if(!fd) return (0);

    /* Find the requested file, ignore case */
    ret = unzLocateFile(fd, filename, 2);
    if(ret != UNZ_OK) return (0);

    /* Get information on the current file */
    ret = unzGetCurrentFileInfo(fd, &info, NULL, 0, NULL, 0, NULL, 0);
    if(ret != UNZ_OK) return (0);

    /* Size mismatch? */
    if(size != info.uncompressed_size) return (0);

    /* Open the file for reading */
    ret = unzOpenCurrentFile(fd);
    if(ret != UNZ_OK) return (0);

    /* Read (decompress) the file */
    ret = unzReadCurrentFile(fd, buf, info.uncompressed_size);
    if(ret != info.uncompressed_size) return (0);

    /* Close the current file */
    ret = unzCloseCurrentFile(fd);
    if(ret != UNZ_OK) return (0);

    /* Close the archive */
    ret = unzClose(fd);
    if(ret != UNZ_OK) return (0);

    return (1);
}

